

# python matrix_visualisation.py <job> 
# ver 1.1



from scipy.io import mmread,mmwrite
import scipy.sparse as sp
import matplotlib.pyplot as plt
import matplotlib.colors as colors

from matplotlib.ticker import FuncFormatter,FixedLocator


import numpy as np
import itertools
from numpy import linalg as la

import configparser
import ast

import re

import sys







commline = sys.argv
print ('arguments:',commline)

job = commline[1]


# INI file parsing
Config = configparser.ConfigParser()
Config.read("matrix_eigenvalues.ini")
print ('ini:',Config.sections())

def ConfigSectionMap(section):
    dict1 = {}
    options = Config.options(section)
    for option in options:
        try:
            dict1[option] = Config.get(section, option)
            if dict1[option] == -1:
                DebugPrint("skip: %s" % option)
        except:
            print("exception on %s!" % option)
            dict1[option] = None
    return dict1






# data loading
suffix = ConfigSectionMap("common")['suffix']
prefix = ConfigSectionMap("common")['prefix']

filename = ConfigSectionMap(job)['filename']






file = prefix+filename+suffix
print (file)

A = mmread(file)
Fone = A.todense()
rows = np.shape(Fone)[0]
cols = np.shape(Fone)[1]

print ('rows,cols =',rows,cols)

print (np.shape(Fone))

mini = np.min(np.min(Fone))
maxi = np.max(np.max(Fone))

oodkud = abs(mini)
if abs(maxi)>oodkud:
   oodkud = abs(maxi)

print ( mini,'..',maxi,'; ',oodkud)

for i in range(rows):
   for j in range(cols):
      if Fone[i,j]>0:
        Fone[i,j] = np.log10(1.0+9.0*Fone[i,j]/oodkud)
      elif Fone[i,j]<0:
        Fone[i,j] = -np.log10(1.0+9.0*abs(Fone[i,j]/oodkud))


cislo = oodkud
oodkud = np.ceil(10**(np.log10(cislo)-round(np.log10(cislo))+1))*10**(round(np.log10(cislo)-1))
print (cislo,'->',oodkud)


mini = np.min(np.min(Fone))
maxi = np.max(np.max(Fone))

odkud = abs(mini)
if abs(maxi)>odkud:
  odkud = abs(maxi)

print (mini,'..',maxi,'; ',odkud)


cmapa = colors.LinearSegmentedColormap.from_list("",["navy","blue","skyblue","white","salmon","red","maroon"])

fig = plt.figure()
ax = fig.add_subplot(111)
cax = ax.matshow(Fone,cmap=cmapa,vmin=-odkud,vmax=odkud)
cbar = fig.colorbar(cax)

hits1 = [1.0 + 9.0/float(i) for i in range(1,11)]
hits2 = [1.0 + 9.0/(10.0*float(i)) for i in range(2,11)]
hits = np.concatenate((hits1,hits2))
minors1 = 0.5*np.log10(hits)+0.0
minors2 = -0.5*np.log10(hits)+0.0
minors = np.concatenate((minors1,minors2))


print('minors',minors)

logs = [-1.0,-0.7403,-0.51188,-0.27875,0.0,0.27875,0.51188,0.7403,1.0]
majors = np.array(logs)

cbar.ax.yaxis.set_major_locator(FixedLocator(majors))
cbar.ax.yaxis.set_minor_locator(FixedLocator(minors))




def millions(x,pos):
  logtrue = x*odkud

  if logtrue>=0:
    pomo = (10**abs(logtrue)-1.0)*oodkud/9.0
  else:
    pomo = -(10**abs(logtrue)-1.0)*oodkud/9.0

  return '%1.2f' % (pomo)

formatter = FuncFormatter(millions)
cbar.ax.yaxis.set_major_formatter(formatter)



ax.yaxis.set_major_locator(plt.FixedLocator(np.arange(-0.5,rows,3)))
ax.yaxis.set_major_formatter(plt.NullFormatter())

ax.xaxis.set_major_locator(plt.FixedLocator(np.arange(-0.5,cols,3)))
ax.xaxis.set_major_formatter(plt.NullFormatter())


ax.tick_params(axis='x',colors=(0,0,0,0))
ax.tick_params(axis='y',colors=(0,0,0,0))



ax.grid()


plt.savefig(prefix+filename+'.pdf');plt.savefig(prefix+filename+'.png')



plt.show()





